LeetCode 15 3Sum 解题思路和python代码

题目:

Given an integer array nums, return all the triplets nums\[i, numsj, numsk] such that i != j, i != k, and j != k, and numsi + numsj + numsk == 0.

Notice that the solution set must not contain duplicate triplets.

Example 1:

Input: nums = -1,0,1,2,-1,-4

Output: \[-1,-1,2,-1,0,1]

Explanation:

nums0 + nums1 + nums2 = (-1) + 0 + 1 = 0.

nums1 + nums2 + nums4 = 0 + 1 + (-1) = 0.

nums0 + nums3 + nums4 = (-1) + 2 + (-1) = 0.

The distinct triplets are -1,0,1 and -1,-1,2.

Notice that the order of the output and the order of the triplets does not matter.

Example 2:

Input: nums = 0,1,1

Output: \[\]

Explanation: The only possible triplet does not sum up to 0.

Example 3:

Input: nums = 0,0,0

Output: \[0,0,0]

Explanation: The only possible triplet sums up to 0.

Constraints:

3 <= nums.length <= 3000

-105 <= numsi <= 105

解题思路:

首先对数组进行排序,有助于使用双指针方法快速找到合适的三元组。

对于每个元素nums[i],将它作为第一个数,然后使用双指针方法在 i 之后的数组部分寻找另外两个数,使它们的和等于0。

左指针从 i+1 开始,右指针从数组末尾开始,逐步向中间收缩。根据三者之和的结果,调整左右指针的位置。

为了避免重复的三元组,遍历时需要跳过相同的元素。

python 复制代码
class Solution(object):
    def threeSum(self, nums):
        """
        :type nums: List[int]
        :rtype: List[List[int]]
        """
        result = []
        nums.sort()

        print("nums: ", nums)

        for i in range(len(nums)):
            print("i: ", i)

            # 如果当前元素和前一个相同,跳过,避免重复三元组
            if i > 0 and nums[i] == nums[i-1]:
                continue
            
            left, right = i+1, len(nums)-1

            while left < right:
                print("nums[i]: ", nums[i])
                print("nums[left]: ", nums[left])
                print("nums[right]: ", nums[right])
                total = nums[i] + nums[left] + nums[right]
                print("total: ", total)

                if total == 0:
                    result.append([nums[i], nums[left], nums[right]])

                    while left < right and nums[left] == nums[left+1]:
                        left+=1
                    while left < right and nums[right] == nums[right-1]:
                        right-=1
                    
                    left+=1
                    right-=1
                
                elif total < 0:
                    left += 1
                else:
                    right -= 1
        
        return result

例子:

nums = -1,0,1,2,-1,-4

首先,对数组进行排序。

('nums: ', -4, -1, -1, 0, 1, 2)

接着,遍历数组。

('i: ', 0)

('numsi: ', -4)

('numsleft: ', -1)

('numsright: ', 2)

('total: ', -3)

和小于0,说明左指针太小,向右移动左指针。

('numsi: ', -4)

('numsleft: ', -1)

('numsright: ', 2)

('total: ', -3)

和还是小于0,说明左指针太小,向右移动左指针。

('numsi: ', -4)

('numsleft: ', 0)

('numsright: ', 2)

('total: ', -2)

和还是小于0,说明左指针太小,向右移动左指针。

('numsi: ', -4)

('numsleft: ', 1)

('numsright: ', 2)

('total: ', -1)

和还是小于0,但 i=0 的遍历结束,进入 i=1。

('i: ', 1)

('numsi: ', -1)

('numsleft: ', -1)

('numsright: ', 2)

('total: ', 0)

和等于0,将三元组加入result。检查左指针指向的数(-1)是否与下一个数(0)相等,如果相等,就要跳过重复的左指针元素;同样道理,检查右指针指向的数(2)是否与前一个数(1)相等,如果相等,就跳过重复的右指针元素。

移动指针后,继续计算和。

('numsi: ', -1)

('numsleft: ', 0)

('numsright: ', 1)

('total: ', 0)

和等于0,将三元组加入result。

左指针大于右指针,遍历结束。

('i: ', 2)

nums2还是 -1,因此跳过。

('i: ', 3)

('numsi: ', 0)

('numsleft: ', 1)

('numsright: ', 2)

('total: ', 3)

左指针大于右指针,遍历结束。

('i: ', 4)

左指针等于右指针,while loop不会开始。

('i: ', 5)

左指针大于右指针,while loop不会开始。

output是 \[-1,-1,2,-1,0,1]

time complexity是O(n^2)

相关推荐
SamChan901 小时前
图片翻译后文字挤出边框?用 Pillow 测量译文,不再靠字符数猜宽度
图像处理·python·pillow·本地化·图片翻译
2601_962780911 小时前
2027风险管理岗准备路线:数学与应用数学专业如何补齐金融、SQL与Python
python·sql·金融
老唐7772 小时前
Transformer原理大白话讲解
人工智能·python·深度学习·神经网络·计算机视觉·ai·transformer
佳木逢钺2 小时前
从火灾模拟到系统热寂:一个双非运维如何用零 GPU 推导出多智能体系统的终极死锁
人工智能·python·算法·多智能体
垆边人似月.2 小时前
网格最小代价路径,总代价不超过 budget
算法
虚无的纽扣2 小时前
【力扣刷题】第五天:将 x 减到 0 的最小操作数、最大连续1的个数 III
算法·leetcode·职场和发展
C++ 老炮儿的技术栈2 小时前
char 造成的数据溢出
linux·服务器·c语言·c++·算法·c
fwc2 小时前
第T9周:猫狗识别2
python·深度学习
砚底藏山河2 小时前
数据新鲜度 SLA 监控
java·大数据·python·maven
Wzx1980122 小时前
Python Agent 短期记忆设计:从对话历史到 LangGraph Checkpointer
开发语言·python